#!/usr/bin/perl

use strict;
use warnings;

use CGI;
use DBI;
use Socket;	# inet_aton

sub webutils_cgiinit($)
{
	$CGI::DISABLE_UPLOADS = 1;
	$CGI::POST_MAX        = 102_400; # 100 KB
	$|=1;

	my $title = shift;
	my $cgi = new CGI;

	print <<"_HTML_";
Content-type: text/html

<HTML>
<HEAD>
<TITLE>$title</TITLE>
<META name="robots" content="noindex,nofollow">
<META name="ROBOTS" content="NOINDEX,NOFOLLOW">
<META http-equiv="Content-Language" content="ru">
<META http-equiv="Content-Style-Type" content="text/css">
<META http-equiv="Content-Type" content="text/html; charset=windows-1251">
</HEAD>
_HTML_
	print $cgi->start_html($title), $cgi->h1($title);

	$cgi;
}

sub webutils_cgidone($)
{
	my $cgi = shift;
	my $now = localtime;
	my $self = $cgi->self_url;
	print $cgi->p("<hr/><em><a href='$self'>$self</a> -- $now</em>");
	print $cgi->end_html;
}

sub webutils_cgiabort($$)
{
	my ($cgi, $msg) = @_;
	print "<h2><font color='red'>$msg</font></h2>\n";
	webutils_cgidone($cgi);
	exit;
}

sub webutils_utminit(;$)
{
	my $dbh = DBI->connect("DBI:mysql:database=arpwatch-db:host=localhost",
				"arpwatch2cgi", "VerySecretPassword2")
		or die "Cannot connect to database ".$DBI::errstr."\n";
	$dbh;
}

sub webutils_queryform
{
	my ($title, $name) = @_;
	my $script_url = $ENV{'SCRIPT_NAME'} || $0;
	print "<form method='get' action='$script_url'>\n";
	print "$title: ";
	print "<input type='text' name='$name'/>\n";
	print "<input type='submit' value='Search!'/>\n";
	print "</form>\n";
}

sub execute_query($$;@)
{
	my ($dbh, $query) = (shift, shift);
	my $sth = $dbh->prepare($query)
		or die "Cannot prepare '$query': ".$dbh->errstr."\n";
	$sth->execute(@_) or die "Cannot execute '$query': ".$sth->errstr."\n";
	$sth;
}

sub ip2long {
	return unpack("l*", pack("l*", unpack("N*", inet_aton(shift))));
}

sub long2ip {
	return inet_ntoa(pack("N*", shift));
}

sub arpw2macstr($) {
	my @a = split(/:/, $_[0]);
	sprintf("%02x:%02x:%02x:%02x:%02x:%02x",
		hex($a[0])||0, hex($a[1])||0, hex($a[2])||0,
		hex($a[3])||0, hex($a[4])||0, hex($a[5])||0);
}

sub macstr2arpwatch($) {
	my @a = split(/[:\-]/, $_[0]);
	sprintf("%x:%x:%x:%x:%x:%x",
		hex($a[0])||0, hex($a[1])||0, hex($a[2])||0,
		hex($a[3])||0, hex($a[4])||0, hex($a[5])||0);
}

sub cgitable_header
{
	print "<table cellpadding='6' border='1'><tr>\n";
	print join("\n",map("  <th align='center'>$_</th>\n", @_));
	print "</tr>\n\n";
}

1;

## EOF ##
