#!/usr/bin/perl

use strict;
use warnings;

use Webutils;

my $cgi = webutils_cgiinit('ARP Watch TopStats');
my $dbh = webutils_utminit();
my $sth;
my $now = time;

my $max_lines = $cgi->param('lines') || 50;

my $script_name = $ENV{SCRIPT_NAME} || $0;
my $period   = $cgi->param('period') || 'all';

my $period_seconds = 0    if $period eq 'all';
$period_seconds = 3600    if $period eq 'hour' or $period eq 'lasthour';
$period_seconds = 3600*24 if $period eq 'day'  or $period eq 'lastday';
$period_seconds = $period if $period =~ /^\d+$/ and $period > 0;

sub mktable($$$$) {
	my ($field_name, $column_name, $param_name, $table_header) = @_;

	print "<h3>$table_header</h3>\n";
	print "<table border='4' cellpadding='6'>\n";
	print "<tr><th>#</th><th>Count</th><th>$column_name</th></tr>\n";

	my $p = ($period_seconds ? "where tstamp > $now - $period_seconds" : "");
	my $q = "select count(*) as cnt, $field_name as val from arpwatch $p"
		." group by $field_name having cnt > 1 order by cnt desc limit $max_lines";
	print "<!-- query = \"$q\" -->\n";
	$sth = execute_query($dbh, $q);
	my $n = 0;
	while ($_ = $sth->fetchrow_hashref) {
		my $val = $_->{val};
		$val = arpw2macstr($val) if $field_name eq 'macaddr';
		print "<tr><td align='right'>".(++$n)."</td>"
			 ."<td align='right'>$_->{cnt}</td>"
			 ."<td><a href='arpwatch.cgi?$param_name=$_->{val}&period=$period'>$val</a></td></tr>"
	}

	print "</table>";
}

print "<h3>Period: $period ($period_seconds seconds). Lines: $max_lines</h3>\n";
print "<table border='0' cellpadding='10'><tr><td valign='top'>\n";
mktable( 'ipaddr', 'IP',  'ip',   'IP top');
print "</td><td valign='top'>\n";
mktable('macaddr', 'MAC', 'mac', 'MAC top');
print "</td></tr></table>\n";
webutils_cgidone($cgi);

## EOF ##
